/********************************************************
v0.01 14.2.08  

********************************************************/


#define abs(x) (((x) >= 0) ? (x) : (- (x))) 

#include <stdio.h>

#define maxlabel 5000
#define maxbuf 40000
#define max_line_lang 160
#define max_if 10

#define max7      63L
#define min7     -64L

#define max8     127L
#define min8    -128L

#define max12   2047L
#define min12  -2048L

#define max16  32767L
#define min16 -32768L

#define high8    255L
#define low8       0L

#define high15 32767L
#define low15      0L

#define high16 65535L
#define low16      0L

#define high22 4194304L
#define low22        0L

#define TAB  9
#define EOL 10
#define CR  13
#define NULL 0
#define BS   8


typedef struct {int x,y,z;} op_typ;

FILE *mac, *lst, *bin, *fopen(), *fopenb();

char lab_buf[maxbuf + max_line_lang+5]; /* Labelnamen              */
char *lab_pa[maxlabel+5];               /* Pointer auf Labelnamen  */
int lab_wert[maxlabel+5];              /* Werte der Labels        */
char lab_guelt[maxlabel+5];             /* 0    : Blockmarkierung  */
                                        /* 1/-1 : lokales Label    */
                                        /* 2/-2 : normales Label   */
                                        /* 3/-3 : globales Label   */
                                        /* 4    : @-Label          */
                                        /* negativ: Wert ungueltig */
int lab_block=2;              /* Nummer des letzen Blockbeginns    */
int lab_lokal=2;              /* Nummer des ersten lokalen  Labels */
int lab_last= -1;             /* Nummer des letzen eingetr. Labels */


char last_line[160];
int  l_line_lang=0;

int  if_wert=0;
int  list_level=0;

int  last_ch=0;
int  next_ch;
int  line_nr=1;
int  line_sp=0;
int  pass2=0;
int  blk_flag=0;
int  odd=0;

int in_ram=0;
int ram_p=0x4000, ram_pp=0, ram_blk_flag=0, ram_odd=0;
int rom_p       , rom_pp  , rom_blk_flag  , rom_odd  ;
FILE *ram_bin=NULL, *rom_bin=NULL;

/*************************************************************/

main()
{
 int li,lj,lk;
 int i,j;
 char *p,*q;

 char if_stack[max_if+5];
 int  if_level=0;

 char opcode[max_line_lang];
 char operand[max_line_lang];

 op_typ  op1,op2,op3;

 char file_name[20];

 print_string("\n  *****************************************");
 print_string("\n  *                                       *");
 print_string("\n  *   M   M  DDDD   EEEEE  L       AAA    *");
 print_string("\n  *   MM MM  D   D  E      L      A   A   *");
 print_string("\n  *   M M M  D   D  EEEE   L      AAAAA   *");
 print_string("\n  *   M   M  D   D  E      L      A   A   *");
 print_string("\n  *   M   M  DDDD   EEEEE  LLLLL  A   A   *");
 print_string("\n  *                                       *");
 print_string("\n  *                                       *");
 print_string("\n  *                                       *");
 print_string("\n  *             Version 0.01              *");
 print_string("\n  *               14.02.08                *");
 print_string("\n  *                                       *");
 print_string("\n  *                                       *");
 print_string("\n  *****************************************");
 print_string("\n\n");
 print_string("\n\n  Filename (ohne .mac): ");

 i=0;
 p=file_name;
 while (1)
    {*p = getc(stdin);
     if (*p == EOL || *p == CR || *p == '.') break;
     if (i<8) p++,i++;
    }
 *p++ = '.';  *p++ = 'm';  *p++ = 'a';  *p++ = 'c';  *p = 0; 

 mac = fopen(file_name,"r");
 if (mac==NULL) ende(1,31);
 next_ch = getc(mac);


 lab_pa[0]=lab_buf;
 lab_guelt[0]=0;
 ins_lab("@",0L,4);
 ins_lab("@@",0L,4);
 print_string("\n Pass 1\n");

 do
   {
    if (pass2) 
     { /*ini pass 2*/
       fclose(mac);
       last_ch=0;
       mac = fopen(file_name,"r");
       if (mac==NULL) ende(2,31);
       next_ch = getc(mac);
       p=file_name; while (*p++ != '.'); *p++ = 'l'; *p++ = 's'; *p = 't'; 
       lst = fopen(file_name,"w");
       if (lst==NULL) ende(3,32);

       p=file_name; while (*p++ != '.'); *p++ = 'r'; *p++ = 'o'; *p = 'm'; 
       rom_bin = fopen(file_name,"wb");
       if (rom_bin==NULL) ende(4,33);
       p=file_name; while (*p++ != '.'); *p++ = 'r'; *p++ = 'a'; *p = 'm'; 
       ram_bin = fopen(file_name,"wb");
       if (ram_bin==NULL) ende(4,33);
       bin=rom_bin;

       line_nr=1;
       line_sp=0;
       blk_flag=0;
       lab_wert[0]=0;
       lab_wert[1]=0;
       lab_block=2;
       lab_lokal=2;
       if_level=0;
       if_wert=0;
       list_level=0;

        odd=0; 
        ram_p=0x4000; ram_pp=0; ram_blk_flag=0; ram_odd=0;

       print_string(" Pass 2\n");
     }

    while (get_opcode(opcode))
     {if (cmps(opcode,"if")) goto _if;
      if (cmps(opcode,"else")) goto _else;
      if (cmps(opcode,"endif")) goto _endif;
      if (if_wert < 0) {skip_line(); goto nextline;}

      switch(opcode[0]) 
       {case  0 : break;
        case '=': {j=2; goto op__;};
        case ':': {j=3; goto op__;};
        case 'a': goto op_a;
        case 'b': goto op_b;
        case 'c': goto op_c;
        case 'd': goto op_d;
        case 'e': goto op_e;
        case 'f': goto op_f;
        case 'g': goto op_g;
        case 'h': goto op_h;
        case 'i': goto op_i;
        case 'j': goto op_j;
        case 'k': goto op_k;
        case 'l': goto op_l;
        case 'm': goto op_m;
        case 'n': goto op_n;
        case 'o': goto op_o;
        case 'p': goto op_p;
        case 'q': goto op_q;
        case 'r': goto op_r;
        case 's': goto op_s;
        case 't': goto op_t;
        case 'u': goto op_u;
        case 'v': goto op_v;
        case 'w': goto op_w;
        case 'x': goto op_x;
        case 'y': goto op_y;
        case 'z': goto op_z;
        default:  ende(5,1);
       }

      nextline: 

      read_eol();
     }
    if (if_wert) ende(6,27); 
    pass2=!pass2;
   } while (pass2);

 fclose(mac); mac=NULL;
 if (rom_bin!=NULL) {fclose(rom_bin); rom_bin=NULL;}
 if (ram_bin!=NULL) {fclose(ram_bin); ram_bin=NULL;}
 list_label();
 fclose(lst); lst=NULL;
 decout(file_name);
 ende(0,0);

/*************************************************************/
/*************************************************************/


op__:
 p=opcode;
 while (*++p);
 *opcode = *--p;
 *p=0;
 if (opcode[0]=='_') j=1; 
 get_operand(operand);
 i=get_w(operand,&li); 
 if (!i) j = -j;
 ins_lab(opcode,li,j);
 goto nextline;

op_a:
 if (cmps(opcode,"add"))       goto _add;
 ende(7,1);

op_b:
 if (cmps(opcode,"blk.b"))      goto _blkb;
 if (cmps(opcode,"blk.w"))      goto _blkw;
 if (cmps(opcode,"blk.l"))      goto _blkl;
 if (cmps(opcode,"br"))        goto _br;
 if (cmps(opcode,"bcc"))       goto _br;
 if (cmps(opcode,"bne"))       goto _br;
 ende(8,1);

op_c:
 ende(9,1);

op_d:
 if (cmps(opcode,"dc.b"))       goto _dcb;
 if (cmps(opcode,"dc.bw"))      goto _dcbw;
 if (cmps(opcode,"dc.l"))       goto _dcl;
 if (cmps(opcode,"dc.w"))       goto _dcw;
 if (cmps(opcode,"dcw"))        goto _dcw;
 ende(10,1);

op_e:
 if (cmps(opcode,"even"))       goto _even;
 ende(11,1);

op_f:
 ende(12,1);

op_g:
 ende(13,1);

op_h:
 ende(14,1);

op_i:
 ende(15,1);

op_j:
 ende(16,1);

op_k:
 ende(17,1);

op_l:
 if (cmps(opcode,"label_block")) goto _label;
 if (cmps(opcode,"list"))        goto _list;
 ende(18,1);

op_m:
 if (cmps(opcode,"move"))        goto _move;
 ende(19,1);

op_n:
 if (cmps(opcode,"nor"))        goto _nor;
 if (cmps(opcode,"nolist"))     goto _nolist;
 ende(20,1);

op_o:
 if (cmps(opcode,"odd"))        goto _odd;
 ende(21,1);

op_p:
 ende(22,1);

op_q:
 ende(23,1);

op_r:
 if (cmps(opcode,"ram"))        goto _ram;
 if (cmps(opcode,"rom"))        goto _rom;
 ende(24,1);

op_s:
 ende(25,1);

op_t:
 ende(26,1);

op_u:
 ende(27,1);

op_v:
 ende(28,1);

op_w:
 ende(29,1);

op_x:
 ende(30,1);

op_y:
 ende(31,1);

op_z:
 ende(32,1);


/*************************************************************/
/*************************************************************/
_if:
 get_operand(operand);
 if (if_level > max_if) ende(33,28);
 if_stack[if_level++] = if_wert;
 if (if_wert<0) {if_wert = -2; goto nextline;}
 if (! get_w(operand,&li)) ende(34,10);
 if (li) if_wert = 1; else if_wert = -1;
 goto nextline;

_else:
 if (if_wert ==  1 || if_wert ==  -2) {if_wert = -3; goto nextline;}
 if (if_wert == -1)                   {if_wert =  2; goto nextline;}
 ende(35,29);

_endif:
 if (!if_level) ende(36,30);
 if_wert = if_stack[--if_level];
 goto nextline;
  

/*************************************************************/
_add:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.x != 2  || op2.x != 2) ende(37,9);
 aus_word(0x0000 + op1.z);
 aus_word(0x0000 + op2.z);
 goto nextline;

/*************************************************************/

_br:
 get_operand(operand);
 get_wert(operand,&li);
 if (pass2 && ((unsigned int)li > high15)) ende(40,6);
 aus_word(0x8000 + li);
 goto nextline;

/*************************************************************/

/*************************************************************/
_blkb:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(41,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += (li+1)/2; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) != 1) ende(42,4);
 for (;li>0;li--)  aus_byte((int)lj);
 if (odd) aus_byte(0);
 goto nextline;
 

_blkl:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(43,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li*2; blk_flag=1; goto nextline;}
 get_wert(operand,&lj);
 for (;li>0;li--)  aus_long(lj);
 goto nextline;


_blkw:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(44,10);
 get_operand(operand);
 if (! (*operand)) {*lab_wert += li*1; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) > 2) ende(45,5);
 for (;li>0;li--)  aus_word((int)lj);
 goto nextline;


/*************************************************************/

/*************************************************************/

_dcb:
 while (1)
  {get_operand(operand);
   if (! *operand) {if (odd) aus_byte(0); goto nextline;}

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(46,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) aus_byte(*q++);
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(47,4);
   aus_byte((int)li);
  }

_dcbw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(48,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) {aus_byte(*q++); aus_byte(0);}
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(49,4);
   aus_byte((int)li); aus_byte(0);
  }

_dcl:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   get_wert(operand,&li);
   aus_long(li);
  }

_dcw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   if (get_wert(operand,&li) > 2) ende(50,5);
       aus_word((int)li);
  }

/*************************************************************/
_even:
 li=2; lj=0;
 get_operand(operand);
 if (*operand) 
    {if (! get_w(operand,&li)) ende(51,9);
     get_operand(operand);
     if (*operand) if (get_wert(operand,&lj) != 1) ende(52,4);
    }
 if (lk = *lab_wert%li) for (;lk<li;lk++) aus_word((int)lj);
 goto nextline;
  
/*************************************************************/


_label:
 if (!pass2)
     {++lab_last;
      if (lab_last > maxlabel) ende(53,24);
      lab_block=lab_last+1;
      lab_pa[lab_block]=lab_pa[lab_last];
      lab_guelt[lab_block]=0;
     }
     else
     {lab_block=lab_lokal;
      while (lab_guelt[lab_block++]);
     }
 goto nextline;

/*************************************************************/

_list:
 list_level++;
 goto nextline;

/*************************************************************/

_move:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 dec_operand("#$ffff",&op3); 

 if (op1.x != 2  || op2.x != 2) ende(56,9);
 aus_word(0x0000 + op3.z);
 aus_word(0x8000 + op2.z);
 aus_word(0x0000 + op1.z);
 aus_word(0x0000 + op2.z);
 goto nextline;


/*************************************************************/

_nolist:
 list_level--;
 goto nextline;

_nor:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.x != 2  || op2.x != 2) ende(56,9);
 aus_word(0x0000 + op1.z);
 aus_word(0x8000 + op2.z);
 goto nextline;


/*************************************************************/
_odd:
 if (!( *lab_wert & (int) 1) ) aus_byte(0x00);
 goto nextline;


/*************************************************************/

/*************************************************************/
_ram:
 if (!in_ram) {rom_p =lab_wert[0];    lab_wert[0]=ram_p;
               rom_pp=lab_wert[1];    lab_wert[1]=ram_pp;
               rom_blk_flag=blk_flag; blk_flag=ram_blk_flag;
               rom_odd=odd;           odd=ram_odd;
               bin=ram_bin;
              }
 goto nextline;

_rom:
 if (in_ram)  {ram_p =lab_wert[0];    lab_wert[0]=rom_p;
               ram_pp=lab_wert[1];    lab_wert[1]=rom_pp;
               ram_blk_flag=blk_flag; blk_flag=rom_blk_flag;
               ram_odd=odd;           odd=rom_odd;
               bin=rom_bin;
              }
 goto nextline;


/*************************************************************/


} /* end main */




/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int out_byte(i) int i;
{char *p;

 putc(i,bin);
 
 if (blk_flag)
    {print_string("\nACHTUNG: Code generiert nach blk-Anweisung in Zeile ");
     print_dec(line_nr);
     print_string("\nblk reserviert keinen Speicherplatz\n");
     blk_flag=0;
    }
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_byte(i) int i;
{if (pass2) 
    {if (line_sp > 36) list_char(EOL);
     list_byte(i);
     list_char(' ');
     out_byte(i);
    }
 
 if (odd) { (*lab_wert)++; lab_wert[1]++; odd=0;}
     else odd=1;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_word(i) int i;
{if (pass2) 
    {if (line_sp > 34) list_char(EOL);
     list_byte(i>>8);
     list_byte(i);
     list_char(' ');
     out_byte(i>>8);
     out_byte(i);
    }

 (*lab_wert) += 1;
 lab_wert[1] += 1;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_long(i) int i;
{if (pass2) 
    {if (line_sp > 30) list_char(EOL);
     list_byte( (int)(i>>24) );
     list_byte( (int)(i>>16) );
     list_byte( (int)(i>>8) );
     list_byte( (int) i );
     list_char(' ');
     out_byte( (int)(i>>24) );
     out_byte( (int)(i>>16) );
     out_byte( (int)(i>>8) );
     out_byte( (int) i );
    }

 (*lab_wert) += 2;
 lab_wert[1] += 2;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_byte(i) int i;
{int j;
 if (!line_sp)
    {
     line_sp=1;

     list_byte( (int)(lab_wert[1] >> 24));
     list_byte( (int)(lab_wert[1] >> 16));
     list_byte( (int)(lab_wert[1] >>  8));
     list_byte( (int)(lab_wert[1]      ));
     list_char(':');
     list_char(' ');

     list_byte( (int)( (*lab_wert) >> 24));
     list_byte( (int)( (*lab_wert) >> 16));
     list_byte( (int)( (*lab_wert) >>  8));
     list_byte( (int)( (*lab_wert)      ));
     list_char(':');
     list_char(' ');
     line_sp -= 1;
    }

 j = (i>>4)&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');

 j = i&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_char(i) int i;
{if (list_level >= 0) {/* putc(i,stdout);*/ putc(i,lst);}
 if (i==EOL) line_sp = 0; else line_sp += 1;
}



/*************************************************************/
/* return 1:byte  2:word  3:long Operand                     */
/*************************************************************/

int get_wert(p,li) char *p; int *li;
{int i;
 if (i=get_w(p,li)) return (i);
 if (!pass2) {*li=0; return (1);}
 ende(57,10);
}

/*************************************************************/
/* return 0:Berechnung nicht meglich                         */
/*        1:byte  2:word  3:long Operand                     */
/*************************************************************/
#define max_tiefe 20

/*

hoechste Prioritaet
 ()             : Klammern
 !   ~   -      : logisches not, binaeres not, Minus-Vorzeichen
 *   /   \      : Multiplikation, Division, Rest (2er-Komplement-Darst.)
 +   -          : Addition, Subtraktion
 <<  >>         : Linksshift, Rechtsshift
 <   >   <=  >= : kleiner, groesser, kleiner-gleich, groesser-gleich
 ==  !=         : gleich, nicht gleich
 &              : binaeres AND
 ^              : binaeres XOR
 |              : binaeres OR
 &&             : logisches UND    (FALSE = 0;  TRUE=alles andere
 ||             : logisches ODER    TRUE als Ergebnis = 1)
niedrigste Prioritaet

Bei gleicher Prioritaet von links nach rechts ausser bei (! ~ -),
hier von rechts nach links.

!   : 0x00   (%000000 00)
~   : 0x01   (%000000 01)
-   : 0x02   (%000000 10)
*   : 0x04   (%000001 00)
/   : 0x05   (%000001 01)
\   : 0x06   (%000001 10)
+   : 0x08   (%000010 00)
-   : 0x09   (%000010 01)
<<  : 0x0c   (%000011 00)  
>>  : 0x0d   (%000011 01)
<   : 0x10   (%000100 00)
>   : 0x11   (%000100 01)
<=  : 0x12   (%000100 10)
>=  : 0x13   (%000100 11)
==  : 0x14   (%000101 00)
!=  : 0x15   (%000101 01)
&   : 0x18   (%000110 00)
^   : 0x1c   (%000111 00)
|   : 0x20   (%001000 00)
&&  : 0x24   (%001001 00)
||  : 0x28   (%001010 00)
NULL: 0x2c   (%001011 00)
(   : 0x30   (%001100 00)
)   : 0x31   (%001100 01)


*/

int get_w(p,li) char *p; int *li;
{int i=0,j=0,k;
 int la[max_tiefe+5];
 char ca[max_tiefe+5];

 ca[0]=0x34;

 while (1)
  {while (1)
    {if (i > max_tiefe || j > max_tiefe) ende(58,26);
     if (!*p) ende(59,11);
     if (*p == '(') {ca[++i]= 0x30; p++; continue;}
     if (*p == '!') {ca[++i]= 0x00; p++; continue;}
     if (*p == '~') {ca[++i]= 0x01; p++; continue;}
     if (*p == '-') {ca[++i]= 0x02; p++; continue;}

     if (*p == '$' || *p == '%' || *p == '"' || *p == '\'' || buchzahl(*p))
        {if (!get_zahl(&p,&la[++j])) return 0; break; }
     ende(60,12);
    }

   while (1) 
    {switch (*(p++))
        {case '*' : {k=0x04; break;}
         case '/' : {k=0x05; break;}
         case '\\': {k=0x06; break;}
         case '+' : {k=0x08; break;}
         case '-' : {k=0x09; break;}
         case '<' : {if (*p == '<') {k=0x0c; p++; break;}
                     if (*p == '=') {k=0x12; p++; break;}
                     k=0x10; break;}
         case '>' : {if (*p == '>') {k=0x0d; p++; break;}
                     if (*p == '=') {k=0x13; p++; break;}
                     k=0x11; break;}
         case '=' : {if (*p == '=') {k=0x14; p++; break;}
                     ende(61,14);}
         case '!' : {if (*p == '=') {k=0x15; p++; break;}
                     ende(62,14);}
         case '&' : {if (*p == '&') {k=0x24; p++; break;}
                     k=0x18; break;}
         case '^' : {k=0x1c; break;}
         case '|' : {if (*p == '|') {k=0x28; p++; break;}
                     k=0x20; break;}
         case ')' : {k=0x31; break;}
         case  0  : {k=0x2c; break;}
         default  : ende(63,14);
        }

     while ( (k|0x03) >= ca[i] )
        {if (j<1) ende(64,14); /*eigentlich unmoeglich*/
         switch(ca[i--])
            { case 0x00: {     la[j] = !la[j]          ; break;}
              case 0x01: {     la[j] = ~la[j]          ; break;}
              case 0x02: {     la[j] = -la[j]          ; break;}
              case 0x04: {j--; la[j] = la[j] *  la[j+1]; break;}
              case 0x05: {j--; la[j] = la[j] /  la[j+1]; break;}
              case 0x06: {j--; la[j] = la[j] %  la[j+1]; break;}
              case 0x08: {j--; la[j] = la[j] +  la[j+1]; break;}
              case 0x09: {j--; la[j] = la[j] -  la[j+1]; break;}
              case 0x0c: {j--; la[j] = la[j] << la[j+1]; break;}
              case 0x0d: {j--; la[j] = la[j] >> la[j+1]; break;}
              case 0x10: {j--; la[j] = la[j] <  la[j+1]; break;}
              case 0x11: {j--; la[j] = la[j] >  la[j+1]; break;}
              case 0x12: {j--; la[j] = la[j] <= la[j+1]; break;}
              case 0x13: {j--; la[j] = la[j] >= la[j+1]; break;}
              case 0x14: {j--; la[j] = la[j] == la[j+1]; break;}
              case 0x15: {j--; la[j] = la[j] != la[j+1]; break;}
              case 0x18: {j--; la[j] = la[j] &  la[j+1]; break;}
              case 0x1c: {j--; la[j] = la[j] ^  la[j+1]; break;}
              case 0x20: {j--; la[j] = la[j] |  la[j+1]; break;}
              case 0x24: {j--; la[j] = la[j] && la[j+1]; break;}
              case 0x28: {j--; la[j] = la[j] || la[j+1]; break;}
              case 0x30: goto weiter;
              default:   ende(65,14);
            }
        }
     if (k==0x2c) goto fertig;
     ca[++i] = k;
     break;
weiter:;
    }
  }

fertig:
 if (i || --j) ende(66,14);
 *li=la[1];
 if ( !(*li & ~high8)  || !(~*li & min8) ) return 1;
 if ( !(*li & ~high16) || !(~*li & min16)) return 2;
 return 3;

}


/*************************************************************/
/* Rueckgabewert  0: Zahl konnte nicht berechnet werden      */
/*                1: Zahl konnte berechnet werden            */
/*************************************************************/

int get_zahl(pp,lip)  char **pp; int *lip;
{char *q;
 int i,j;

 q = *pp;
 *lip = 0;

 if (*q>='0' && *q<='9') 
    {while (*q >= '0' && *q <= '9') *lip = 10 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='%') 
    {q++;
     while (*q == '0' || *q == '1') *lip = 2 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='$')
    {q++;
     while ( (i='0', *q >= '0' && *q <= '9') || 
             (i='a'-10, *q >= 'a' && *q <= 'f')    )
     *lip = 16 * (*lip) + *q++ -i;
     *pp = q;
     return 1;}

 if ( (i = *q) == '\'' || i == '"')
    {q++;
     for (j=1; j<=4; j++)
         {if (! *q ) {*pp = q; return 1;}
          if (*q == i) {*pp = q+1; return 1;}
          *lip = (*lip << 8) + *q++;
         }
     if (*q == i) {*pp = q+1; return 1;}
     ende(67,22);
    }

 if (buchst(*q))
    { while (buchzahl(*++q));
      i = *q;
      *q = 0;
      if (get_lab(*pp,lip)) {*q = i; *pp = q; return 1;}
      *q = i;
    }
 return 0;
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int get_operand(p) char *p;
{int ch,i=0,j=0;

 while ((ch=read_char()) == ' ');
 if (ch==EOL) {p[0]=0; return;}
 while ( (p[i++]=ch) != EOL ) ch=read_char();
 p[--i]=0;
 del_blank(p);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int del_blank(p) char *p;
{char *q,*p1;
 int ch=0, l_ch, l_bz;
 int instring=0;

 q=p;
 while (l_ch=ch, ch = *q++ = *p++)
   {if (l_ch!=' ') l_bz=buchzahl(l_ch);
    if (ch==instring) {instring=0; continue;}
    if (instring)  continue;
    if (ch=='\'' || ch=='"') {instring=ch; continue;}
    if (ch==' ') q--;
    if ( !(l_ch==' ' && buchzahl(ch) && l_bz) ) continue;
    p1=p; while(*++p1 == ' ');
    if (ch!='.' || *p!='b' && *p!='w'  && *p!='l' 
                || *p1!=0  && *p1!='(' && *p1!='{'     ) ende(68,17);
   }
 *q++ = 0;
}
      


/*************************************************************
 x     y       z
   
 1     -       -        : kein Operand
 2     -      adr15     : adr15
 *************************************************************/

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int dec_operand(p,op) char *p; op_typ *op;

{int i;
 int par[5];
 char *q;
 
 if (!*p) {op->x=1; return;}
 
    {op->x=2;
     get_wert(p,&op->z);
     if (pass2 && ( (unsigned int)(op->z))>high15) ende(69,11);
     return;
    }

 ende(70,9);
}


/*************************************************************/
/* Rueckgabewert  0:nicht gefunden  1: gefunden              */
/*************************************************************/

int finds(p,q,pi) char *p,*q; int *pi;
{int i=0,j=0;

 while (*p) { i++; p++;} --p;
 while (*q) { j++; q++;} --q;

 while (j--)
  {if (!(i--)) return 0;
   if ( *q != '?') if (*p-- == *q--) continue; else return 0;
   if ( *p < '0' || *p > '9') return 0;
   if ( i==0 || *(p-1) < '1' || *(p-1) > '3' || (*(p-1) == '3' && *p > '1')) 
      {*pi++ = *p-- - '0';  q--; continue;}
   *pi++ = (*(p-1)-'0')*10 + *p - '0'; p-=2; q--; i--;
  }
 *++p = 0;
 return 1;
}
 

/*************************************************************/
/* Rueckgabewert  0:nicht gleich  1: gleich                  */
/*************************************************************/

int cmps(p,q) char *p,*q;
{while (*p && *p==*q) p++,q++;
 return *p?0:!*q;
}


/*************************************************************/
/* Rueckgabewert  0: kein Opcode  1:Opcode gefunden          */
/*************************************************************/

int get_opcode(p) char *p;
{int ch,i;
 char *q;


 while (1)
  {q=p; q[0]=0;
   while ( (ch=read_char()) == ' ');
   if (last_ch==EOF) return 0;
   if (ch==EOL) return 1;
   if (!buchst(ch)) ende(71,12);
   while (*q++=ch, buchzahl(ch=read_char()));

   if (ch == ' ') 
      {while (next_ch == ' ') ch = read_char();
       if (next_ch == ':' || next_ch == '=') ch = read_char();
      }

   if (ch=='=') 
      {while (next_ch == ' ') read_char();
       *q++ = *p; *q = 0;
       if (next_ch == '=') {read_char();  *p = ':'; return 1;}
          else                          { *p = '='; return 1;}
      }

   *q=0;
   if (ch==EOL || ch==' ') return 1;
   if (ch!=':') ende(72,12);

   while (next_ch == ' ') read_char();
   if (next_ch == ':')  {read_char(); i=3;} else i=2;
   if (if_wert<0) continue;
   if (p[0]=='_') i=1;  
   ins_lab(p,*lab_wert,i);
  }
}

/*************************************************************/
/* Rueckgabewert  Nummer des Labels  -1 falls nicht vorhanden*/
/*************************************************************/

int find_lab(p) char *p;
{int i,j;

 if (*p == '_')
    {i=lab_lokal-1;
     do         /*10.2.94*/
      {i++; 
       while ( (j=abs(lab_guelt[i])) ==1) if (cmps(lab_pa[i++],p)) return i-1;
      } 
     while ( j==4 || (j && (*lab_pa[i]=='.')) );
     return -1;
    }

 i=lab_block;
 while (lab_guelt[i]!=0) 
       {if (abs(lab_guelt[i])==2 && cmps(lab_pa[i],p)) return i;
        i++;
       }

 i=0;
 while (i<=lab_last)
       {if (   (abs(lab_guelt[i])==3 || lab_guelt[i]==4)
            && cmps(lab_pa[i],p)) return i;
        i++;
       }

 return -1;

}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int ins_lab(p,wert,g) char *p; int wert; int g;
{char *q;
 int i=0;

 q=p;
 while (*q++) if (*q == '.') ende(73,18); /*10.2.94*/

 if (*p == '@') if (g<0 ) ende(74,10); else g=4; 

 if ( (i=find_lab(p)) >= 0)
    {if (!pass2 && g != 4 ) ende(75,19); 
     lab_wert[i]=wert; lab_guelt[i]=g;
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
    }
 else
    {q=lab_pa[(i = ++lab_last)];
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
     if ( q > (lab_buf + maxbuf) ) ende(76,23);
     while (*q++ = *p++);
     if (lab_last > maxlabel) ende(77,24);
     lab_wert[i]=wert;
     lab_guelt[i]=g;
     lab_pa[i+1]=q;
     lab_guelt[i+1]=0;
    }
}


/*************************************************************/
/* return 0:ungueltiger  1:gueltiger  Labelwert              */
/*************************************************************/

int get_lab(p,wert) char *p; int *wert;
{int i=0;

 if ( (i=find_lab(p)) >= 0) 
    {*wert=lab_wert[i];
     if (lab_guelt[i]>0) return 1;
    }
 return 0;

}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_label()
{int i,j;
 int li;
 char *p;

 list_char(EOL);
 line_sp=110;

 for (i=0; i <= lab_last; i++) 
   {p = lab_pa[i];
    if ( lab_guelt[i] > 1 && *p != '@')
       {if (line_sp > 64) list_char(EOL);
           else for (j=0; j<3; j++) list_char(' ');
        j=0;
        while (*p) {list_char(*p++); j++;}
        while (j < 15) {list_char('.'); j++;}
        list_char(' ');
        li = lab_wert[i];
        list_byte( (int)(li>>24) );
        list_byte( (int)(li>>16) );
        list_byte( (int)(li>>8) );
        list_byte( (int) li );
       }
   }
}
 

/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe  1:Buchstabe              */
/*************************************************************/

int buchst(ch) char ch;
{if (ch=='.' || ch=='_' || ch=='@'|| ch=='#') return 1;
 if (ch >= 'a' && ch <= 'z' )  return 1;
 return 0;
}


/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe/Zahl  1:Buchstabe/Zahl    */
/*************************************************************/

int buchzahl(ch) char ch;
{
 return (buchst(ch) || (ch=='$') || ( ch>='0' && ch<='9' ) );
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int skip_line()
{while (last_ch != EOL && last_ch != EOF) read_char();
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int read_eol()
{int i;
 if (last_ch != EOL && last_ch != EOF) 
    {while (read_char() == ' ');
     if (last_ch != EOL && last_ch != EOF) ende(78,20);
    }
 if (last_ch == EOL) last_ch=0;

 if (pass2) 
    {while (line_sp < 40) list_char(' ');
     for (i=0;i<l_line_lang;i++) list_char(last_line[i]);
     l_line_lang=0;
    }

 line_nr++;
 return;
}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int read_char()
{int ch;
 static int instring = 0;

 if ( (ch=get_char()) == ';' && !instring) 
    { while ( (ch=get_char()) != EOL );
      return (ch);
    }

 if (ch == instring) {instring=0; return (ch);}
 if (instring==')') goto abc;
 if (instring) return(ch);
 if (ch == '\'' || ch == '"') {instring=ch; return(ch);}
 if (ch == '(' ) {instring=')'; return (ch);} /* kein Ende bei , */
 if (ch ==',') return (EOL);
abc:
 if (ch >= 'A' && ch <= 'Z') ch+='a'-'A';

 return (ch);

}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int get_char()
{if (last_ch==EOL || last_ch==EOF) return EOL;
 last_ch = next_ch;
 next_ch = getc(mac);
 if ( last_ch  == EOF ) return (EOL);
 if (last_ch==TAB) last_ch=' ';
 if (last_ch==CR) if (next_ch==EOL) last_ch=' '; else last_ch=EOL;
 
if (pass2) 
    { if (l_line_lang >= max_line_lang) ende(79,21);
      last_line[l_line_lang++]=last_ch; 
    }
/*    else putc(last_ch,stdout);
*/

 return (last_ch);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {
/*  0 */ "Normales Ende" ,
/*  1 */ "Unbekannter Opcode" ,
/*  2 */ "-" ,
/*  3 */ "-" ,
/*  4 */ "Byte-Wert zu gross" ,
/*  5 */ "Word-Wert zu gross" ,
/*  6 */ "Zu grosser Sprungoffset" ,
/*  7 */ "-" ,
/*  8 */ "-" ,
/*  9 */ "Ungueltige Adressierung od. Operand" ,
/* 10 */ "Label nicht gefunden" ,
/* 11 */ "Kein Wert" ,
/* 12 */ "Ungueltiges Zeichen" ,
/* 13 */ "-" ,
/* 14 */ "Ungueltiger Ausdruck" ,
/* 15 */ "-" ,
/* 16 */ "-" ,
/* 17 */ "Ungueltiges Leerzeichen" ,
/* 18 */ "Punkt im Label" ,
/* 19 */ "Label doppelt definiert" ,
/* 20 */ "Zu viele Operanden" ,
/* 21 */ "Zu lange Eingabezeile" ,
/* 22 */ "Zu lange ASCII-Konstante" ,
/* 23 */ "Labelpuffer voll" ,
/* 24 */ "Pointer-Array fuer Label voll" ,
/* 25 */ "Ungueltige ASCII-Konstante" ,
/* 26 */ "Zu viele Klammern" ,
/* 27 */ "Felendes ENDIF" ,
/* 28 */ "Zu viele IF's" ,
/* 29 */ "Zu viele ELSE's" , 
/* 30 */ "Zu viele ENDIF's", 
/* 31 */ "Quelltextdatei konnte nicht geoeffnet werden", 
/* 32 */ "Listdatei konnte nicht geoeffnet werden" ,
/* 33 */ "BIN-Datei konnte nicht geoeffnet werden" ,
/* 34 */ "MEM.MEM konnte nicht geoeffnet werden" ,
/* 35 */ "MEM.ORG konnte nicht geoeffnet werden" ,
/* 36 */ "MEM.SCH konnte nicht geoeffnet werden" 
};
 print_string("\n\n");
 print_dec(j);
 print_string(" : ");
 print_string(meld[i]);
 print_string(" in Zeile "); 
 print_dec(line_nr);
 print_string("\n");

 if (mac!=NULL) fclose(mac);
 if (pass2) {if (lst!=NULL) fclose(lst); 
             if (ram_bin!=NULL) fclose(bin);
             if (rom_bin!=NULL) fclose(bin);}
 exit(0);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_string(p) char *p;

{while (*p) putc(*p++,stdout);
}


/*************************************************************/
/*************************************************************/
/*************************************************************/

FILE *dec;

int decout(file_name) char *file_name;
{int i,j,k,m,n;
 char *p;

 bin = fopen(file_name,"rb");
 if (bin==NULL) ende(80,33);

 dec = fopen("ram_data.txt","wb");
 if (dec==NULL) ende(81,34);

 n=j=0;
 do {if ( (i=getc(bin)) != EOF) 
      if ( (j=getc(bin)) != EOF) {decout_word(n++);
                                  decout_word((i<<8)+j);
                                  decout_char(13);
                                  decout_char(10);
                                 }
    } while (i!=EOF && j!=EOF);

 fclose(bin);
 fclose(dec);

; p=file_name; while (*p++ != '.'); *p++ = 'r'; *p++ = 'o'; *p = 'm'; 
 bin = fopen(file_name,"rb");
 if (bin==NULL) ende(80,33);

 dec = fopen("rom_data.txt","wb");
 if (dec==NULL) ende(81,34);

 n=j=0;
 do {if ( (i=getc(bin)) != EOF) 
      if ( (j=getc(bin)) != EOF) {decout_word(n++);
                                  decout_word((i<<8)+j);
                                  decout_char(13);
                                  decout_char(10);
                                 }
    } while (i!=EOF && j!=EOF);

 fclose(bin);
 fclose(dec);

 
}

int decout_char(i) int i;
{putc(i,dec);}

int decout_word(i) int i;
{int k,j=1;
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',dec);
      i -= k*j;
      j /= 10;
     }
 decout_char(' ');
}

/*************************************************************/
/*************************************************************/
/*************************************************************/
