--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : ISE
--  /   /         Filename : mprozsim.vhw
-- /___/   /\     Timestamp : Wed May 16 13:13:34 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: mprozsim
--Device: Xilinx
--

library UNISIM;
use UNISIM.Vcomponents.ALL;
library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE STD.TEXTIO.ALL;

ENTITY mprozsim IS
END mprozsim;

ARCHITECTURE testbench_arch OF mprozsim IS
    COMPONENT mproz
        PORT (
            clk : In std_logic;
            reset : In std_logic;
            inport : In std_logic_vector (7 DownTo 0);
            irq : In std_logic;
            a : Out std_logic_vector (14 DownTo 0);
            iosel : Out std_logic;
            oe : Out std_logic;
            outport : Out std_logic_vector (7 DownTo 0);
            ramsel : Out std_logic;
            romsel : Out std_logic;
            rw : Out std_logic;
            d : InOut std_logic_vector (15 DownTo 0)
        );
    END COMPONENT;

    SIGNAL clk : std_logic := '0';
    SIGNAL reset : std_logic := '1';
    SIGNAL inport : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL irq : std_logic := '1';
    SIGNAL a : std_logic_vector (14 DownTo 0) := "000000000000000";
    SIGNAL iosel : std_logic := '0';
    SIGNAL oe : std_logic := '0';
    SIGNAL outport : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL ramsel : std_logic := '0';
    SIGNAL romsel : std_logic := '0';
    SIGNAL rw : std_logic := '0';
    SIGNAL d : std_logic_vector (15 DownTo 0) := "ZZZZZZZZZZZZZZZZ";

    constant PERIOD : time := 30 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : mproz
        PORT MAP (
            clk => clk,
            reset => reset,
            inport => inport,
            irq => irq,
            a => a,
            iosel => iosel,
            oe => oe,
            outport => outport,
            ramsel => ramsel,
            romsel => romsel,
            rw => rw,
            d => d
        );

        PROCESS    -- clock process for clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                WAIT FOR 10 ns;
                inport <= "00110101";
                -- -------------------------------------
                WAIT FOR 50000 ns;
                irq <= '0';
                -- -------------------------------------
                WAIT FOR 5000 ns;
                irq <= '1';
                -- -------------------------------------
                WAIT FOR 5000000 ns;

            END PROCESS;

    END testbench_arch;

